# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

# If you want repolib package to be built,
# issue the following: 'rpmbuild --with repolib'

%define _with_repolib 1

%define with_repolib %{?_with_repolib:1}%{!?_with_repolib:0}
%define without_repolib %{!?_with_repolib:1}%{?_with_repolib:0}

%define repodir %{_javadir}/repository.jboss.com/jfreechart/%{version}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

# If you want the demo to be built,
# give rpmbuild option '--with demo'

%define with_demo %{?_with_demo:1}%{!?_with_demo:0}
%define without_demo %{!?_with_demo:1}%{?_with_demo:0}

%define	section		free

Name:			jfreechart
Version:		1.0.13
Release:		2.3.2.1.1%{?dist}
Epoch:			0
Summary:		Charts Generation library
License:		LGPLv2+
URL:			http://www.jfree.org/jfreechart/
#Source from http://www.jfree.org/jfreechart/download.html
Source0:		%{name}-%{version}.tar.gz
Source1:		%{name}-component-info.xml
#Source from http://repository.jboss.org/maven2//jfree/jfreechart/1.0.13/jfreechart-1.0.13.pom
Source2:                %{name}-%{version}.pom
Source3:		jfreechart-upload.sh
Patch0:			%{name}-%{version}-build_xml.patch
Group:			Development/Libraries/Java
# Dependencies included in zip
Requires:		jcommon >= 0:1.0.16
BuildRequires:		ant
BuildRequires:		itext
BuildRequires:		jaxp
BuildRequires:		jcommon >= 0:1.0.16
BuildRequires:		jpackage-utils >= 0:1.7.3
BuildRequires:		junit
#BuildRequires:		tomcat6-servlet-2.5-api
BuildRequires:          jbossweb-servlet-2.5-api
BuildRequires:          maven-deploy-plugin
BuildArch:		noarch
BuildRoot:		%{_tmppath}/%{name}-%{version}-%{release}-root
Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3

%description
Free Java class library for generating charts.

%if %{with_repolib}
%package repolib
Summary:	Artifacts to be uploaded to a repository library
Group:		Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio
%endif

%if %{with_demo}
%package demo
Summary:        Demo for %{name}
Group:          Development/Java
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       jcommon
#Requires:       servlet
Requires:        sevlet_2_5_api
%description demo
Demos for %{name}.
%endif

%package javadoc
Summary:	Javadoc for %{name}
Group:		Development/Documentation

%description javadoc
Javadoc for %{name}.

%description javadoc -l fr
Javadoc pour %{name}.

%prep
%setup -q
# remove all binary libs
find . -name "*.jar" | xargs %{__rm}

ln -sf $(build-classpath jcommon) lib
#ln -sf $(build-classpath tomcat6-servlet-2.5-api) lib/servlet.jar
ln -sf $(build-classpath jbossweb-servlet-2.5-api) lib/servlet.jar
   
%if %{without_demo}
%patch0 -p1
%endif

%if %{with_repolib}
tag=`echo %{version}-brew`
sed -i "s/@VERSION@/$tag/g" %{SOURCE1}
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{SOURCE1}
%endif

%build
export OPT_JAR_LIST=:
export CLASSPATH=
#ant -f ant/build.xml -Dgnujaxp.jar=%{_javadir}/jaxp.jar -Ditext.jar=%{_javadir}/itext.jar -Djunit.jar=%{_javadir}/junit.jar -Djcommon.jar=%{_javadir}/jcommon.jar -Dservlet.jar=%{_javadir}/tomcat6-servlet-2.5-api.jar -Dbuildstable=true -Dproject.outdir=. -Dbasedir=.
ant -f ant/build.xml -Dgnujaxp.jar=%{_javadir}/jaxp.jar -Ditext.jar=%{_javadir}/itext.jar -Djunit.jar=%{_javadir}/junit.jar -Djcommon.jar=%{_javadir}/jcommon.jar -Dservlet.jar=%{_javadir}/jbossweb-servlet-2.5-api.jar -Dbuildstable=true -Dproject.outdir=. -Dbasedir=.


%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 lib/%{name}-%{version}.jar $RPM_BUILD_ROOT%{_javadir}
%if %{with_demo}
install -m 644 %{name}-%{version}-demo.jar $RPM_BUILD_ROOT%{_javadir}
%endif
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*.jar; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# pom
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap jfree %{name} %{version} JPP %{name}

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr javadoc/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%if %{with_repolib}
	install -d -m 755 $RPM_BUILD_ROOT%{repodir}
	install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
	install -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{repodir}/component-info.xml
	install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{PATCH0} $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{SOURCE2} $RPM_BUILD_ROOT%{repodirlib}/%{name}.pom
	cp -p $RPM_BUILD_ROOT%{_javadir}/jfreechart.jar $RPM_BUILD_ROOT%{repodirlib}
	install -p -m 755 %{SOURCE3} %{buildroot}%{repodir}/upload.sh	
	pushd %{buildroot}%{repodir}
	./upload.sh %{buildroot}/usr/share/java/repository.jboss.com/maven2-brew/
	popd
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc 
%{_javadir}*/%{name}.jar
%{_javadir}*/%{name}-%{version}.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%if %{with_demo}
%files demo
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}-%{version}-demo.jar
%{_javadir}*/%{name}-demo.jar
%endif

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %{with_repolib}
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Tue Nov 23 2010 Yiqiao Wang <yiwang@redhat.com> - 0:1.0.13-2.3.2.1.1
- Build with Maven 2.2.1
- Add upload.sh to repolib
- Fix %%files for signed jars
- Add content of maven2-brew

* Mon May 17 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.0.13-2.3.2.1
- rebuilt

* Tue Apr 20 2010 Luiz Barreiros <gbarreir@redhat.com> 0:1.0.13-2.3.2
- Rebuild

* Thu Apr 1 2010 Yiqiao Wang <yiwang@redhat.com> 0:1.0.13-2.3.1.1
- Merge from RHEL-4

* Thu Mar 16 2010 Yiqiao Wang <yiwang@redhat.com> 0:1.0.13-2.3.1
- Change BR tomcat6-servlet-2.5-api to jbossweb-servlet-2.5-api
- Change R servlet to R sevlet_2_5_api

* Mon Aug 24 2009 Martha Benitez <mbenitez@redhat.com> 0:1.0.13-2.3
- Correct pom name in repolib

* Mon Aug 24 2009 Martha Benitez <mbenitez@redhat.com> 0:1.0.13-2.2
- Remove version from pom file in repolib

* Mon Aug 24 2009 Martha Benitez <mbenitez@redhat.com> 0:1.0.13-2.1
- Add pom.xml to repolib
- Change BR jcommon >= 1.0.16

* Tue Aug 18 2009 Ralph Apel <r.apel@r-apel.de> 0:1.0.13-2.jpp6
- Add pom and depmap frag
- Restore some changelog entries (?)

* Mon Aug 17 2009 Martha Benitez <mbenitez@redhat.com> 0:1.0.13-1.jpp6
- Upgrade to 1.0.13

* Tue Dec 16 2008 David Walluck <dwalluck@redhat.com> 0:1.0.9-4
- update component-info.xml to export jcommon.jar

* Tue Dec 16 2008 David Walluck <dwalluck@redhat.com> 0:1.0.9-3
- add documentation files
- add jcommon to repolib
- fix repolib file permissions
- fix repolib file ownership
- fix component-info.xml

* Fri May 30 2008 David Walluck <dwalluck@redhat.com> 0:1.0.9-2.jpp5
- fix %%doc
- fix macro in %%changelog

* Mon Mar 31 2008 Clive Saldanha <csaldanh@redhat.com> - 0:1.0.9-1jpp.ep1.3
- Removed the post/postun javadoc sections and added to %%files javadoc instead

* Fri Jan 18 2008 Clive Saldanha <csaldanh@redhat.com> - 0:1.0.9-1jpp.ep1.2
- Fixed Typo in component-info.xml

* Fri Jan 18 2008 Clive Saldanha <csaldanh@redhat.com> - 0:1.0.9-1jpp.ep1.1
- Upgrade to 1.0.9

* Sat Feb 17 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:0.9.21-2jpp.el4ep1.1
- Add repolib support

* Fri Apr 21 2006 Fernando Nasser <fnasser@redhat.com> - 0:0.9.21-2jpp_1rh
- Merge with upstream for upgrade
- Make demo subpackage optional

* Fri Apr 21 2006 Fernando Nasser <fnasser@redhat.com> - 0:0.9.21-2jpp
- First JPP 1.7 build

* Tue Sep 20 2005 Ralph Apel <r.apel at r-apel.de> - 0:0.9.21-1jpp
- Upgrade to 0.9.21 

* Mon Apr 25 2005 Fernando Nasser <fnasser@redhat.com> - 0:0.9.20-1jpp_1rh
- First Red Hat build

* Thu Dec 02 2004 Ralph Apel <r.apel at r-apel.de> - 0:0.9.20-1jpp
- Upgrade to 0.9.20 (last version with -demo included, for jboss32)

* Sun Nov 14 2004 Ville Skyttä <scop at jpackage.org> - 0:0.9.16-3jpp
- Remove bogus batik dependency.

* Sun Aug 23 2004 Randy Watler <rwatler at finali.com> - 0.9.16-2jpp
- Rebuild with ant-1.6.2

* Tue Feb 17 2004 Kaj J. Niemi <kajtzu@fi.basen.net> 0.9.16-1jpp
- 0.9.16

* Fri May 09 2003 David Walluck <david@anti-microsoft.org> 0:0.9.8-1jpp
- 0.9.8
- update for JPackage 1.5

* Fri Mar 11 2003 Henri Gomez <hgomez@users.sourceforge.net> 0.9.6-2jpp
- update spec to respect JPP 1.5 policy

* Tue Mar 08 2003 Henri Gomez <hgomez@users.sourceforge.net> 0.9.6-1jpp
- 0.9.6
- requires jcommon 0.7.2 min
- no more sub package test

* Mon Oct 28 2002 Henri Gomez <hgomez@users.sourceforge.net> 0.9.4-1jpp
- Initial release
